from multiprocessing.queues import Queue
from multiprocessing import Process
import multiprocessing
from GOESLayer import GOESLayer
from GOESLayerExample import GOESLayerExample
from CADULayer import CADULayer
from PrintLayer import PrintLayer
import time

layer1 = GOESLayerExample()
layer2 = GOESLayerExample()
layer3 = GOESLayerExample()
printLayer = PrintLayer()

layer1.connect(layer2.getInBuffer())
layer2.connect(layer3.getInBuffer())
layer3.connect(printLayer.getInBuffer())

p1 = Process(target=layer1.threadFunction)
p2 = Process(target=layer2.threadFunction)
p3 = Process(target=layer3.threadFunction)
p4 = Process(target=printLayer.threadFunction)

p1.daemon = True
p2.daemon = True
p3.daemon = True
p4.daemon = True

p1.start()
p2.start()
p3.start()
p4.start()

for i in range(0,10):
   layer1.getInBuffer().put(i)

layer1.getInBuffer().join()
layer2.getInBuffer().join()
layer3.getInBuffer().join()
printLayer.getInBuffer().join()
